'''
Simple class to keep track of whether or not we are in a macro action. 
Also tracks how many steps are in the macro action
'''
import random as rand

class MacroAction():

    _MARINE = 48
    _PLAYER_FRIENDLY = 1
    _NUM_ACTIONS = 4

    def __init__ (self):
        self.macroCounter = 0
        self.marineTags = []
        self.action = 0

    def setMacroSteps (self, numSteps):
        self.macroCounter = numSteps

    def completeMacroStep (self):
        self.macroCounter -= 1

    def checkMacroComplete (self):
        if self.macroCounter == 0:
            return True
        else:
            return False

    '''
    Moving the army. Grab all Friendly marine tags. Issue orders indivudally
    '''

    def setMarineTags (self, obs):
        for unit in obs.observation.raw_units:
            if unit.unit_type == self._MARINE and \
                unit.alliance == self._PLAYER_FRIENDLY: #You wanna a piece of me?
                    self.marineTags.append(unit.tag)

        self.macroCounter = len(self.marineTags)

    def getMarineTag (self):
        self.completeMacroStep()
        if len(self.marineTags) > 0:
            return self.marineTags.pop()
        else:
            return None

    def isNewOrder (self):
        return len(self.marineTags) <= 0
    
    def generateAction (self, training, model, obs):
        if training == True:
            self.action = rand.randint(0,3)
        else:
            self.action = model.predictMove(obs)
        #self.action = 0

    def setAction (self, action): #Expect to use this with a trained NN
        self.action = action

    def getAction (self):
        return self.action